
# When downloading directly from Mercurial, it will automatically add this prefix
# Invoking 'hg archive' wont but you can add one with:
# hg archive -t tgz -p "Linux-HA-Dev-" -r $upstreamversion $upstreamversion.tar.gz
%global specversion 1
#global upstreamprefix Linux-HA-Dev-
%global upstreamprefix Heartbeat-3-0-
%global upstreamversion heartbeat-30git

#global alphatag %{upstreamversion}.hg

%global           ENABLE_SNMP_SUBAGENT 0
%global           gname haclient
%global           uname hacluster

Summary:          Messaging and membership subsystem for High-Availability Linux
Name:             heartbeat
Version:          3.0
# For dev snapshots
Release:          9.10
License:          GPLv2 and LGPLv2+
URL:              http://linux-ha.org/
Group:            System Environment/Daemons
# For dev snapshots
Source0:          heartbeat-30git.tar.gz
Patch1:           heartbeat-3.0.4-disable-xinclude.patch
Patch2:           heartbeat-3.0.0-haresources.patch
#Patch3:		  fix-ftbfs-lp1188428.patch
BuildRoot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n) 
BuildRequires:    glib2-devel
BuildRequires:    iputils
BuildRequires:    libnet-devel
BuildRequires:    libtool-ltdl-devel
BuildRequires:    net-snmp-devel >= 5.4
BuildRequires:    bzip2-devel 
BuildRequires:    ncurses-devel
BuildRequires:    openssl-devel
BuildRequires:    libtool
BuildRequires:    libxml2-devel
BuildRequires:    gettext
BuildRequires:    bison
BuildRequires:    flex
BuildRequires:    zlib-devel
BuildRequires:    mailx
BuildRequires:    which
BuildRequires:    cluster-glue-libs-devel
BuildRequires:    libuuid-devel
BuildRequires:    libxslt
BuildRequires:    docbook-style-xsl
BuildRequires:	  python
Requires:	  python
Requires:         PyXML
Requires:         resource-agents
Requires:         cluster-glue-libs
Requires(pre):    shadow-utils
Requires(pre):    cluster-glue
Requires(post):   /sbin/chkconfig
Requires(preun):  /sbin/chkconfig
Obsoletes:        heartbeat-gui < %{version}-%{release}

%description
heartbeat is a basic high-availability subsystem for Linux-HA.
It will run scripts at initialization, and when machines go up or down.
This version will also perform IP address takeover using gratuitous ARPs.

Heartbeat contains a cluster membership layer, fencing, and local and
clusterwide resource management functionality.

When used with Pacemaker, it supports "n-node" clusters with significant 
capabilities for managing resources and dependencies.

In addition it continues to support the older release 1 style of
2-node clustering.

It implements the following kinds of heartbeats:
        - Serial ports
        - UDP/IP multicast (ethernet, etc)
        - UDP/IP broadcast (ethernet, etc)
        - UDP/IP heartbeats
        - "ping" heartbeats (for routers, switches, etc.)
           (to be used for breaking ties in 2-node systems)

%package libs
Summary:          Heartbeat libraries
Group:            System Environment/Daemons
Requires:         heartbeat

%description libs
Heartbeat library package

%package devel 
Summary:        Heartbeat development package 
Group:          System Environment/Daemons
Requires:       heartbeat

%description devel
Headers and shared libraries for writing programs for Heartbeat

%prep
%setup -q -n %{upstreamversion}
%patch1 -p1
%patch2 -p1 

%build
./bootstrap
# disable-fatal-warnings flag used to disable gcc4.x warnings of 'difference in signedness'
CFLAGS=${RPM_OPT_FLAGS} %configure  --disable-fatal-warnings --disable-static

# get rid of rpath
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
# disable xsltproc from trying to hit the net
export XSLTPROC_OPTIONS=""
make DESTDIR=$RPM_BUILD_ROOT install

# cleanup
[ -d $RPM_BUILD_ROOT/usr/man ] && rm -rf $RPM_BUILD_ROOT/usr/man
[ -d $RPM_BUILD_ROOT/usr/share/libtool ] && rm -rf $RPM_BUILD_ROOT/usr/share/libtool
find $RPM_BUILD_ROOT -type f -name *.la -exec rm -f {} ';'
mv $RPM_BUILD_ROOT/%{_datadir}/doc/%{name} $RPM_BUILD_ROOT/%{_datadir}/doc/%{name}-%{version}
rm -rf $RPM_BUILD_ROOT/%{_datadir}/heartbeat/cts

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
/sbin/chkconfig --add heartbeat

%postun -p /sbin/ldconfig

%preun
if [ $1 = 0 ] ; then
    /sbin/service heartbeat stop
    /sbin/chkconfig --del heartbeat
fi

/sbin/ldconfig

%files
%defattr(-,root,root,-)

%doc %{_datadir}/doc/%{name}-%{version}
%dir %{_sysconfdir}/ha.d
%{_sysconfdir}/ha.d/harc
%{_sysconfdir}/ha.d/rc.d
%config(noreplace) %{_sysconfdir}/ha.d/README.config
%{_datadir}/heartbeat/
%{_sysconfdir}/ha.d/resource.d/
/usr/lib/tmpfiles.d/heartbeat.conf
/usr/lib/systemd/system/heartbeat.service
%{_libexecdir}/heartbeat/*
/etc/rc.d/init.d/heartbeat
%config(noreplace) %{_sysconfdir}/logrotate.d/heartbeat
%dir %{_var}/lib/heartbeat
%dir %{_var}/run/heartbeat
%attr (2755, %{uname}, %{gname}) %{_bindir}/cl_status
%{_bindir}/cl_respawn
%dir %attr (755, %{uname}, %{gname}) %{_var}/run/heartbeat/ccm
%{_mandir}/man1/cl_status.1*
%{_mandir}/man1/hb_standby.1*
%{_mandir}/man1/hb_takeover.1*
%{_mandir}/man1/hb_addnode.1*
%{_mandir}/man1/hb_delnode.1*
%{_mandir}/man8/heartbeat.8*
%{_mandir}/man8/apphbd.8*
%{_mandir}/man5/authkeys.5*
%{_mandir}/man5/ha.cf.5*
%if %{ENABLE_SNMP_SUBAGENT}
/LINUX-HA-MIB.mib
%endif

%files libs
%defattr(-,root,root,-)
%{_libdir}/heartbeat
%{_libdir}/libapphb.so.*
%{_libdir}/libccmclient.so.*
%{_libdir}/libclm.so.*
%{_libdir}/libhbclient.so.*

%files devel
%defattr(-,root,root,-)
%doc %{_datadir}/doc/%{name}-%{version}
%{_includedir}/heartbeat/
%{_includedir}/saf/
%{_includedir}/ocf/
%{_libdir}/*.so

%changelog
* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0.4-1.2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

